Package: geb.navigator

## [Groovy] Class DefaultNavigator

- geb.navigator.DefaultNavigator

- All Implemented Interfaces and Traits:
    Navigator

      class DefaultNavigator
      extends Object
      implements Navigator

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected static Object` | `BOOLEAN_ATTRIBUTES` |
    `protected static Object` | `ELEMENTS_WITH_MUTABLE_VALUE` |
    `protected Iterable<WebElement>` | `contextElements` |
    `protected NavigatorEventListener` | `eventListener` |

  - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `Browser` | `browser`
    `Locator` | `locator`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `DefaultNavigator(Browser browser, Iterable<? extends WebElement> contextElements)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `Navigator` | `add(String selector)`
    `` | `Navigator` | `add(By bySelector)`
    `` | `Navigator` | `add(WebElement[] elements)`
    `` | `Navigator` | `add(Collection<WebElement> elements)`
    `` | `Collection<WebElement>` | `allElements()`
    `` | `boolean` | `asBoolean()`
    `` | `String` | `attr(String name)`
    `` | `Navigator` | `children()`
    `` | `Navigator` | `children(Map<String, Object> attributes)`
    `` | `Navigator` | `children(Map<String, Object> predicates, String selector)`
    `` | `List<String>` | `classes()`
    `` | `Navigator` | `click()`
    `` | `Navigator` | `click(Class<? extends Page> pageClass, Wait wait)`
    `` | `Navigator` | `click(Page pageInstance, Wait wait)`
    `` | `Navigator` | `click(List potentialPages, Wait wait)`
    `` | `Navigator` | `closest(Map<String, Object> attributes)`
    `` | `Navigator` | `closest(Map<String, Object> predicates, String selector)`
    `` | `protected Collection<WebElement>` | `collectAncestors(Closure filter)`
    `` | `protected Collection<WebElement>` | `collectChildren(Closure filter)`
    `` | `protected List<WebElement>` | `collectElements(Closure closure)`
    `` | `protected Collection<WebElement>` | `collectFollowingSiblings(Closure filter)`
    `` | `protected Collection<WebElement>` | `collectParents(Closure filter)`
    `` | `protected Collection<WebElement>` | `collectPreviousSiblings(Closure filter)`
    `` | `protected Collection<WebElement>` | `collectRelativeElements(String xpath, Closure filter)`
    `` | `protected Collection<WebElement>` | `collectSiblings(Closure filter)`
    `` | `protected Collection<WebElement>` | `collectUntil(Collection<WebElement> elements, Closure matcher)`
    `` | `protected Collection<WebElement>` | `collectUntil(Collection<WebElement> elements, Map<String, Object> attributes)`
    `` | `protected Collection<WebElement>` | `collectUntil(Collection<WebElement> elements, Map<String, Object> attributes, String selector)`
    `` | `String` | `css(String propertyName)`
    `` | `protected boolean` | `dynamic(Map<String, Object> attributes)`
    `` | `protected List<String>` | `elementClasses(WebElement element)`
    `` | `Iterator<WebElement>` | `elementIterator()`
    `` | `protected WebElement` | `ensureContainsAtMostSingleElement(String name, Class<?>[] parameterTypes)`
    `` | `Navigator` | `eq(int index)`
    `` | `boolean` | `equals(Object obj)`
    `` | `Navigator` | `filter(Map<String, Object> predicates, String selector)`
    `` | `Navigator` | `filter(String selector)`
    `` | `Navigator` | `filter(Map<String, Object> predicates)`
    `` | `Navigator` | `findAll(Closure predicate)`
    `` | `Navigator` | `first()`
    `` | `WebElement` | `firstElement()`
    `` | `Navigator` | `getAt(int index)`
    `` | `Navigator` | `getAt(Range range)`
    `` | `Navigator` | `getAt(Collection indexes)`
    `` | `String` | `getAttribute(String name)`
    `` | `WebElement` | `getElement(int index)`
    `` | `List<WebElement>` | `getElements(Range range)`
    `` | `List<WebElement>` | `getElements(Collection indexes)`
    `` | `int` | `getHeight()`
    `` | `protected Object` | `getInputValue(WebElement input)`
    `` | `protected Object` | `getInputValues(Collection<WebElement> inputs)`
    `` | `JQueryAdapter` | `getJquery()`
    `` | `String` | `getStringRepresentation()`
    `` | `protected Object` | `getValue(WebElement input)`
    `` | `int` | `getWidth()`
    `` | `int` | `getX()`
    `` | `int` | `getY()`
    `` | `Navigator` | `has(String selector)`
    `` | `Navigator` | `has(Map<String, Object> predicates)`
    `` | `Navigator` | `has(Map<String, Object> predicates, String selector)`
    `` | `Navigator` | `has(By bySelector)`
    `` | `Navigator` | `has(Map<String, Object> predicates, By bySelector)`
    `` | `boolean` | `hasClass(String valueToContain)`
    `` | `Navigator` | `hasNot(String selector)`
    `` | `Navigator` | `hasNot(Map<String, Object> predicates)`
    `` | `Navigator` | `hasNot(Map<String, Object> predicates, String selector)`
    `` | `Navigator` | `hasNot(By bySelector)`
    `` | `Navigator` | `hasNot(Map<String, Object> predicates, By bySelector)`
    `` | `int` | `hashCode()`
    `` | `Navigator` | `head()`
    `` | `boolean` | `is(String tag)`
    `` | `boolean` | `isDisplayed()`
    `` | `boolean` | `isEmpty()`
    `` | `boolean` | `isFocused()`
    `` | `Iterator<Navigator>` | `iterator()`
    `` | `protected String` | `labelFor(WebElement input)`
    `` | `Navigator` | `last()`
    `` | `WebElement` | `lastElement()`
    `` | `Navigator` | `leftShift(Object value)`
    `` | `protected Closure<Boolean>` | `matchingSelectorAndPredicates(String selector, Map<String, Object> predicates)`
    `` | `Object` | `methodMissing(String name, Object arguments)`
    `<T extends Module>` | `T` | `module(Class<T> moduleClass)`
    `<T extends Module>` | `T` | `module(T module)`
    `<T extends Module>` | `List<T>` | `moduleList(Class<T> moduleClass)`
    `<T extends Module>` | `List<T>` | `moduleList(Closure<T> moduleFactory)`
    `` | `protected Navigator` | `navigatorFor(Collection<WebElement> contextElements)`
    `` | `protected Navigator` | `navigatorFor(boolean dynamic, Supplier<Collection<WebElement>> contextElementsSupplier)`
    `` | `protected Navigator` | `navigatorForMatching(boolean dynamic, Closure<?> partialNavigatorPredicate)`
    `` | `Navigator` | `next()`
    `` | `Navigator` | `next(Map<String, Object> attributes)`
    `` | `Navigator` | `next(Map<String, Object> predicates, String selector)`
    `` | `Navigator` | `nextAll()`
    `` | `Navigator` | `nextAll(Map<String, Object> attributes)`
    `` | `Navigator` | `nextAll(Map<String, Object> predicates, String selector)`
    `` | `Navigator` | `nextUntil(Map<String, Object> attributes)`
    `` | `Navigator` | `nextUntil(Map<String, Object> attributes, String selector)`
    `` | `Navigator` | `not(String selector)`
    `` | `Navigator` | `not(Map<String, Object> predicates, String selector)`
    `` | `Navigator` | `not(Map<String, Object> predicates)`
    `` | `Navigator` | `parent()`
    `` | `Navigator` | `parent(Map<String, Object> attributes)`
    `` | `Navigator` | `parent(Map<String, Object> predicates, String selector)`
    `` | `Navigator` | `parents()`
    `` | `Navigator` | `parents(Map<String, Object> attributes)`
    `` | `Navigator` | `parents(Map<String, Object> predicates, String selector)`
    `` | `Navigator` | `parentsUntil(Map<String, Object> attributes)`
    `` | `Navigator` | `parentsUntil(Map<String, Object> attributes, String selector)`
    `` | `Navigator` | `plus(Navigator navigator)`
    `` | `Navigator` | `prevAll()`
    `` | `Navigator` | `prevAll(Map<String, Object> attributes)`
    `` | `Navigator` | `prevAll(Map<String, Object> predicates, String selector)`
    `` | `Navigator` | `prevUntil(Map<String, Object> attributes)`
    `` | `Navigator` | `prevUntil(Map<String, Object> attributes, String selector)`
    `` | `Navigator` | `previous()`
    `` | `Navigator` | `previous(Map<String, Object> attributes)`
    `` | `Navigator` | `previous(Map<String, Object> predicates, String selector)`
    `` | `Object` | `propertyMissing(String name)`
    `` | `Object` | `propertyMissing(String name, Object value)`
    `` | `Navigator` | `remove(int index)`
    `` | `protected boolean` | `select(WebElement input)`
    `` | `protected boolean` | `setCheckboxValue(WebElement input, Object value)`
    `` | `void` | `setEventListener(NavigatorEventListener listener)`
    `` | `protected boolean` | `setInputValue(WebElement input, String tagName, Object value, boolean suppressStaleElementException)`
    `` | `protected void` | `setInputValues(Iterable<WebElement> inputs, Object value)`
    `` | `protected Object` | `setSelectValue(WebElement element, Object value)`
    `` | `Navigator` | `siblings()`
    `` | `Navigator` | `siblings(Map<String, Object> attributes)`
    `` | `Navigator` | `siblings(Map<String, Object> predicates, String selector)`
    `` | `WebElement` | `singleElement()`
    `` | `int` | `size()`
    `` | `String` | `tag()`
    `` | `Navigator` | `tail()`
    `` | `String` | `text()`
    `` | `protected Iterable<WebElement>` | `toDynamicIterable(Supplier<Collection<WebElement>> contextElementsSupplier)`
    `` | `String` | `toString()`
    `` | `Navigator` | `unique()`
    `` | `protected boolean` | `unselect(WebElement input)`
    `` | `Object` | `value()`
    `` | `Navigator` | `value(Object value)`
    `` | `Navigator` | `verifyNotEmpty()`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, toString, hashCode, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### protected static final Object BOOLEAN_ATTRIBUTES

    - #### protected static final Object ELEMENTS_WITH_MUTABLE_VALUE

    - #### protected final Iterable<WebElement> contextElements

    - #### protected NavigatorEventListener eventListener

  - ### Property Detail

    - #### final Browser browser

    - #### @Delegate(allNames: true)
      final Locator locator

  - ### Constructor Detail

    - #### DefaultNavigator(Browser browser, Iterable<? extends WebElement> contextElements)

  - ### Method Detail

    - #### Navigator add(String selector)

    - #### Navigator add(By bySelector)

    - #### Navigator add(WebElement[] elements)

    - #### Navigator add(Collection<WebElement> elements)

    - #### @Override
      Collection<WebElement> allElements()

    - #### boolean asBoolean()

    - #### String attr(String name)

    - #### @Override
      Navigator children()

    - #### @Override
      Navigator children(Map<String, Object> attributes)

    - #### @Override
      Navigator children(Map<String, Object> predicates, String selector)

    - #### @Override
      List<String> classes()

    - #### @Override
      Navigator click()

    - #### @Override
      Navigator click(Class<? extends Page> pageClass, Wait wait)

    - #### @Override
      Navigator click(Page pageInstance, Wait wait)

    - #### @Override
      Navigator click(List potentialPages, Wait wait)

    - #### @Override
      Navigator closest(Map<String, Object> attributes)

    - #### @Override
      Navigator closest(Map<String, Object> predicates, String selector)

    - #### protected Collection<WebElement> collectAncestors(@groovy.transform.stc.ClosureParams(value: FromString, options: java.util.List)
      Closure filter)

    - #### protected Collection<WebElement> collectChildren(@groovy.transform.stc.ClosureParams(value: FromString, options: java.util.List)
      Closure filter)

    - #### protected List<WebElement> collectElements(@groovy.transform.stc.ClosureParams(value: SimpleType, options: org.openqa.selenium.WebElement)
      Closure closure)

    - #### protected Collection<WebElement> collectFollowingSiblings(@groovy.transform.stc.ClosureParams(value: FromString, options: java.util.List)
      Closure filter)

    - #### protected Collection<WebElement> collectParents(@groovy.transform.stc.ClosureParams(value: FromString, options: java.util.List)
      Closure filter)

    - #### protected Collection<WebElement> collectPreviousSiblings(@groovy.transform.stc.ClosureParams(value: FromString, options: java.util.List)
      Closure filter)

    - #### protected Collection<WebElement> collectRelativeElements(String xpath, @groovy.transform.stc.ClosureParams(value: FromString, options: java.util.List)
      Closure filter)

    - #### protected Collection<WebElement> collectSiblings(@groovy.transform.stc.ClosureParams(value: FromString, options: java.util.List)
      Closure filter)

    - #### protected Collection<WebElement> collectUntil(Collection<WebElement> elements, Closure matcher)

    - #### protected Collection<WebElement> collectUntil(Collection<WebElement> elements, Map<String, Object> attributes)

    - #### protected Collection<WebElement> collectUntil(Collection<WebElement> elements, Map<String, Object> attributes, String selector)

    - #### @Override
      String css(String propertyName)

    - #### protected boolean dynamic(Map<String, Object> attributes)

    - #### protected List<String> elementClasses(WebElement element)

    - #### @Override
      Iterator<WebElement> elementIterator()

    - #### protected WebElement ensureContainsAtMostSingleElement(String name, Class<?>[] parameterTypes)

    - #### Navigator eq(int index)

    - #### @Override
      boolean equals(Object obj)

    - #### @Override
      Navigator filter(Map<String, Object> predicates, String selector)

    - #### @Override
      Navigator filter(String selector)

    - #### @Override
      Navigator filter(Map<String, Object> predicates)

    - #### Navigator findAll(Closure predicate)

    - #### @Override
      Navigator first()

    - #### WebElement firstElement()

    - #### @Override
      Navigator getAt(int index)

    - #### @Override
      Navigator getAt(Range range)

    - #### @Override
      Navigator getAt(Collection indexes)

    - #### @Override
      String getAttribute(String name)

    - #### WebElement getElement(int index)

    - #### List<WebElement> getElements(Range range)

    - #### List<WebElement> getElements(Collection indexes)

    - #### @Override
      int getHeight()

    - #### protected Object getInputValue(WebElement input)

    - #### protected Object getInputValues(Collection<WebElement> inputs)

    - #### JQueryAdapter getJquery()

    - #### @Override
      String getStringRepresentation()

    - #### protected Object getValue(WebElement input)

    - #### @Override
      int getWidth()

    - #### @Override
      int getX()

    - #### @Override
      int getY()

    - #### Navigator has(String selector)

    - #### Navigator has(Map<String, Object> predicates)

    - #### Navigator has(Map<String, Object> predicates, String selector)

    - #### Navigator has(By bySelector)

    - #### Navigator has(Map<String, Object> predicates, By bySelector)

    - #### @Override
      boolean hasClass(String valueToContain)

    - #### Navigator hasNot(String selector)

    - #### Navigator hasNot(Map<String, Object> predicates)

    - #### Navigator hasNot(Map<String, Object> predicates, String selector)

    - #### Navigator hasNot(By bySelector)

    - #### Navigator hasNot(Map<String, Object> predicates, By bySelector)

    - #### @Override
      int hashCode()

    - #### @Override
      Navigator head()

    - #### @Override
      boolean is(String tag)

    - #### @Override
      boolean isDisplayed()

    - #### @Override
      boolean isEmpty()

    - #### @Override
      boolean isFocused()

    - #### Iterator<Navigator> iterator()

    - #### protected String labelFor(WebElement input)

    - #### @Override
      Navigator last()

    - #### WebElement lastElement()

    - #### @Override
      Navigator leftShift(Object value)

    - #### protected Closure<Boolean> matchingSelectorAndPredicates(String selector, Map<String, Object> predicates)

    - #### Object methodMissing(String name, Object arguments)

    - #### <T extends Module> T module(Class<T> moduleClass)

    - #### <T extends Module> T module(T module)

    - #### <T extends Module> List<T> moduleList(Class<T> moduleClass)

    - #### <T extends Module> @SuppressWarnings(value: [UnnecessaryCollectCall])
      List<T> moduleList(Closure<T> moduleFactory)

    - #### protected Navigator navigatorFor(Collection<WebElement> contextElements)

    - #### protected Navigator navigatorFor(boolean dynamic, Supplier<Collection<WebElement>> contextElementsSupplier)

    - #### protected Navigator navigatorForMatching(boolean dynamic, @groovy.transform.stc.ClosureParams(value: SimpleType, options: geb.navigator.Navigator)
      Closure<?> partialNavigatorPredicate)

    - #### @Override
      Navigator next()

    - #### @Override
      Navigator next(Map<String, Object> attributes)

    - #### @Override
      Navigator next(Map<String, Object> predicates, String selector)

    - #### @Override
      Navigator nextAll()

    - #### @Override
      Navigator nextAll(Map<String, Object> attributes)

    - #### @Override
      Navigator nextAll(Map<String, Object> predicates, String selector)

    - #### @Override
      Navigator nextUntil(Map<String, Object> attributes)

    - #### @Override
      Navigator nextUntil(Map<String, Object> attributes, String selector)

    - #### @Override
      Navigator not(String selector)

    - #### @Override
      Navigator not(Map<String, Object> predicates, String selector)

    - #### @Override
      Navigator not(Map<String, Object> predicates)

    - #### @Override
      Navigator parent()

    - #### @Override
      Navigator parent(Map<String, Object> attributes)

    - #### @Override
      Navigator parent(Map<String, Object> predicates, String selector)

    - #### @Override
      Navigator parents()

    - #### @Override
      Navigator parents(Map<String, Object> attributes)

    - #### @Override
      Navigator parents(Map<String, Object> predicates, String selector)

    - #### @Override
      Navigator parentsUntil(Map<String, Object> attributes)

    - #### @Override
      Navigator parentsUntil(Map<String, Object> attributes, String selector)

    - #### Navigator plus(Navigator navigator)

    - #### @Override
      Navigator prevAll()

    - #### @Override
      Navigator prevAll(Map<String, Object> attributes)

    - #### @Override
      Navigator prevAll(Map<String, Object> predicates, String selector)

    - #### @Override
      Navigator prevUntil(Map<String, Object> attributes)

    - #### @Override
      Navigator prevUntil(Map<String, Object> attributes, String selector)

    - #### @Override
      Navigator previous()

    - #### @Override
      Navigator previous(Map<String, Object> attributes)

    - #### @Override
      Navigator previous(Map<String, Object> predicates, String selector)

    - #### Object propertyMissing(String name)

    - #### Object propertyMissing(String name, Object value)

    - #### @Override
      Navigator remove(int index)

    - #### protected boolean select(WebElement input)

    - #### protected boolean setCheckboxValue(WebElement input, Object value)

    - #### @Override
      void setEventListener(NavigatorEventListener listener)

    - #### protected boolean setInputValue(WebElement input, String tagName, Object value, boolean suppressStaleElementException)

    - #### protected void setInputValues(Iterable<WebElement> inputs, Object value)

    - #### protected Object setSelectValue(WebElement element, Object value)

    - #### @Override
      Navigator siblings()

    - #### @Override
      Navigator siblings(Map<String, Object> attributes)

    - #### @Override
      Navigator siblings(Map<String, Object> predicates, String selector)

    - #### @Override
      WebElement singleElement()

    - #### @Override
      int size()

    - #### @Override
      String tag()

    - #### @Override
      Navigator tail()

    - #### @Override
      String text()

    - #### protected Iterable<WebElement> toDynamicIterable(Supplier<Collection<WebElement>> contextElementsSupplier)

    - #### @Override
      String toString()

    - #### @Override
      Navigator unique()

    - #### protected boolean unselect(WebElement input)

    - #### @Override
      Object value()

    - #### @Override
      Navigator value(Object value)

    - #### @Override
      Navigator verifyNotEmpty()